var jpibfi;
(function (jpibfi) {
    (function (ButtonPosition) {
        ButtonPosition[ButtonPosition["TopLeft"] = 0] = "TopLeft";
        ButtonPosition[ButtonPosition["TopRight"] = 1] = "TopRight";
        ButtonPosition[ButtonPosition["BottomLeft"] = 2] = "BottomLeft";
        ButtonPosition[ButtonPosition["BottomRight"] = 3] = "BottomRight";
        ButtonPosition[ButtonPosition["Middle"] = 4] = "Middle";
    })(jpibfi.ButtonPosition || (jpibfi.ButtonPosition = {}));
    var ButtonPosition = jpibfi.ButtonPosition;
})(jpibfi || (jpibfi = {}));
var jpibfi;
(function (jpibfi) {
    var $ = jQuery;
    var PinButtonGenerator = (function () {
        function PinButtonGenerator(settings, logger) {
            this._settings = settings;
            this._logger = logger;
        }
        PinButtonGenerator.prototype.getImageUrl = function ($elem) {
            return ($.fn.prop && $elem.prop('src')) || $elem.attr('src');
        };
        PinButtonGenerator.prototype.generate = function (indexer) {
            var $anchor = jQuery('<a/>', {
                href: '#',
                "class": 'pinit-button',
                "data-jpibfi-indexer": indexer,
                text: ""
            });
            var that = this;
            $anchor.click(function () {
                that._logger.logString('Pin In button clicked');
                var index = $(this).data("jpibfi-indexer");
                var $image = $('img[data-jpibfi-indexer="' + index + '"]');
                //Bookmark description is created on click because sometimes it's lazy loaded
                var bookmarkDescription = "", descriptionForUrl = "", bookmarkUrl = "";
                //if usePostUrl feature is active, we need to get the data
                if (that._settings.usePostUrl) {
                    var $inputWithData = $image.closest(".jpibfi_container").find("input.jpibfi").first();
                    if ($inputWithData.length) {
                        descriptionForUrl = $inputWithData.data("jpibfi-description");
                        bookmarkUrl = $inputWithData.data("jpibfi-url");
                    }
                }
                bookmarkUrl = bookmarkUrl || that._settings.pageUrl;
                if (that._settings.descriptionOption == 3)
                    bookmarkDescription = $image.attr('title') || $image.attr('alt');
                else if (that._settings.descriptionOption == 2)
                    bookmarkDescription = descriptionForUrl || that._settings.pageDescription;
                else if (that._settings.descriptionOption == 4)
                    bookmarkDescription = that._settings.siteTitle;
                else if (that._settings.descriptionOption == 5)
                    bookmarkDescription = $image.data('jpibfi-description');
                else if (that._settings.descriptionOption == 6)
                    bookmarkDescription = $image.attr('alt');
                bookmarkDescription = bookmarkDescription || (descriptionForUrl || that._settings.pageTitle);
                var imageUrl = 'http://pinterest.com/pin/create/bookmarklet/?is_video=' + encodeURIComponent('false')
                    + "&url=" + encodeURIComponent(bookmarkUrl) + "&media=" + encodeURIComponent(that.getImageUrl($image))
                    + '&description=' + encodeURIComponent(bookmarkDescription);
                window.open(imageUrl, 'Pinterest', 'width=632,height=253,status=0,toolbar=0,menubar=0,location=1,scrollbars=1');
                return false;
            });
            $anchor.mouseenter(function () {
                var $button = $(this);
                clearTimeout($button.data('jpibfi-timeoutId'));
            });
            $anchor.mouseleave(function () {
                var $button = $(this);
                jpibfi.Utils.startHide($button);
            });
            return $anchor;
        };
        return PinButtonGenerator;
    })();
    jpibfi.PinButtonGenerator = PinButtonGenerator;
})(jpibfi || (jpibfi = {}));
var jpibfi;
(function (jpibfi) {
    var Logger = (function () {
        function Logger(printLog) {
            this._printLog = printLog && typeof console !== 'undefined' && typeof console.log !== 'undefined';
            this._jsonStringifyExists = typeof JSON !== 'undefined' && typeof JSON.stringify === 'function';
        }
        Logger.prototype._logObject = function (obj) {
            var out = '';
            for (var p in obj)
                out += p + ': ' + obj[p] + '\n';
            console.log('jpibfi debug: ' + out);
        };
        Logger.prototype.logString = function (message) {
            if (!this._printLog)
                return;
            console.log('jpibfi debug: ' + message);
        };
        Logger.prototype.logObject = function (obj) {
            if (!this._printLog)
                return;
            if (this._jsonStringifyExists)
                console.log('jpibfi debugz: ' + JSON.stringify(obj, null, 4));
            else
                this._logObject(obj);
        };
        return Logger;
    })();
    jpibfi.Logger = Logger;
})(jpibfi || (jpibfi = {}));
var jpibfi;
(function (jpibfi) {
    var Settings = (function () {
        function Settings(settings) {
            this.filterSelector = '*';
            this.notSelector = '';
            this.buttonMarginTop = parseInt(settings.buttonMarginTop);
            this.buttonMarginRight = parseInt(settings.buttonMarginRight);
            this.buttonMarginBottom = parseInt(settings.buttonMarginBottom);
            this.buttonMarginLeft = parseInt(settings.buttonMarginLeft);
            this.buttonPosition = settings.hasOwnProperty('buttonPosition') ? parseInt(settings.buttonPosition) : 4;
            this.debug = settings.hasOwnProperty('debug') ? settings.debug == '1' : false;
            this.descriptionOption = settings.hasOwnProperty('descriptionOption') ? parseInt(settings.descriptionOption) : 1;
            this.imageSelector = settings.imageSelector;
            this.minImageWidth = settings.hasOwnProperty('minImageWidth') ? parseInt(settings.minImageWidth) : 0;
            this.minImageHeight = settings.hasOwnProperty('minImageHeight') ? parseInt(settings.minImageHeight) : 0;
            this.pageDescription = settings.pageDescription;
            this.pageTitle = settings.pageTitle;
            this.pageUrl = settings.pageUrl;
            this.pinImageHeight = parseInt(settings.pinImageHeight);
            this.pinImageWidth = parseInt(settings.pinImageWidth);
            this.retinaFriendly = settings.hasOwnProperty('retinaFriendly') ? settings.retinaFriendly == 1 : false;
            this.siteTitle = settings.siteTitle;
            this.usePostUrl = settings.hasOwnProperty('usePostUrl') ? settings.usePostUrl : true;
            /* SELECTORS*/
            this.containerSelector = settings.containerSelector;
            this.notSelector = settings.hasOwnProperty('disabledClasses') ? jpibfi.Utils.createSelectorFromList(settings.disabledClasses) : '';
            this.filterSelector = settings.hasOwnProperty('enabledClasses') ? jpibfi.Utils.createSelectorFromList(settings.enabledClasses) || "*" : '*';
            this.adjustPinImageSize();
        }
        Settings.prototype.adjustPinImageSize = function () {
            if (this.retinaFriendly) {
                this.pinImageHeight = Math.ceil(this.pinImageHeight / 2);
                this.pinImageWidth = Math.ceil(this.pinImageWidth / 2);
            }
        };
        return Settings;
    })();
    jpibfi.Settings = Settings;
})(jpibfi || (jpibfi = {}));
var jpibfi;
(function (jpibfi) {
    var $ = jQuery;
    var Utils = (function () {
        function Utils() {
        }
        Utils.createSelectorFromList = function (classes) {
            var arrayOfClasses = classes.split(';');
            var selector = "";
            for (var i = 0; i < arrayOfClasses.length; i++) {
                if (arrayOfClasses[i])
                    selector += '.' + arrayOfClasses[i] + ',';
            }
            return selector ? selector.substr(0, selector.length - 1) : selector;
        };
        Utils.startHide = function ($button) {
            var timeoutId = setTimeout(function () {
                $button.remove();
                $('img[data-jpibfi-indexer="' + $button.data('jpibfi-indexer') + '"]').removeClass('pinit-hover');
            }, 100);
            $button.data('jpibfi-timeoutId', timeoutId);
        };
        return Utils;
    })();
    jpibfi.Utils = Utils;
})(jpibfi || (jpibfi = {}));
var jpibfi;
(function (jpibfi) {
    "use strict";
    var $ = jQuery;
    var Plugin = (function () {
        function Plugin(options) {
            this._indexer = 0;
            this._settings = new jpibfi.Settings($.extend({
                pageUrl: document.URL,
                pageTitle: document.title,
                pageDescription: $('meta[name="description"]').attr('content') || "",
            }, options));
            this._logger = new jpibfi.Logger(this._settings.debug);
            this._buttonGenerator = new jpibfi.PinButtonGenerator(this._settings, this._logger);
            this._logger.logObject(this._settings);
        }
        Plugin.prototype.addImages = function () {
            this._logger.logString('>>addImages');
            var $elements = $(this._settings.imageSelector)
                .not(this._settings.notSelector)
                .not('[data-jpibfi-indexer]')
                .filter(this._settings.filterSelector);
            var that = this;
            $elements.each(function () { $(this).attr('data-jpibfi-indexer', that._indexer++); });
            this._logger.logString('Images caught by selectors: ' + this._indexer);
        };
        ;
        Plugin.prototype.init = function () {
            var $containers = $('.jpibfi').closest(this._settings.containerSelector).addClass('jpibfi_container');
            this._logger.logString('Number of containers added: ' + $containers.length);
            this.initImageDelegates();
            $(document).trigger('jpibfi_beforeAddImages', {});
            this.addImages();
            $(document).trigger('jpibfi_afterAddImages', {});
        };
        Plugin.prototype.initImageDelegates = function () {
            var that = this;
            $(document).delegate('img[data-jpibfi-indexer]', 'mouseenter', function () {
                var $image = $(this);
                if ($image[0].clientWidth < that._settings.minImageWidth || $image[0].clientHeight < that._settings.minImageHeight) {
                    $image.removeAttr('data-jpibfi-indexer');
                    return;
                }
                var indexer = $image.data('jpibfi-indexer');
                var $button = $('a.pinit-button[data-jpibfi-indexer="' + indexer + '"]');
                //button doesn't exist so we need to create it
                if ($button.length == 1) {
                    //button exists, we need to clear the timeout that has to remove it
                    clearTimeout($button.data('jpibfi-timeoutId'));
                }
                else {
                    $button = that._buttonGenerator.generate(indexer);
                    var position = $image.offset();
                    var imageDimensions = {
                        width: $image.get(0).clientWidth,
                        height: $image.get(0).clientHeight
                    };
                    switch (that._settings.buttonPosition) {
                        case jpibfi.ButtonPosition.TopLeft:
                            position.left += that._settings.buttonMarginLeft;
                            position.top += that._settings.buttonMarginTop;
                            break;
                        case jpibfi.ButtonPosition.TopRight:
                            position.top += that._settings.buttonMarginTop;
                            position.left = position.left + imageDimensions.width - that._settings.buttonMarginRight - that._settings.pinImageWidth;
                            break;
                        case jpibfi.ButtonPosition.BottomLeft:
                            position.left += that._settings.buttonMarginLeft;
                            position.top = position.top + imageDimensions.height - that._settings.buttonMarginBottom - that._settings.pinImageHeight;
                            break;
                        case jpibfi.ButtonPosition.BottomRight:
                            position.left = position.left + imageDimensions.width - that._settings.buttonMarginRight - that._settings.pinImageWidth;
                            position.top = position.top + imageDimensions.height - that._settings.buttonMarginBottom - that._settings.pinImageHeight;
                            break;
                        case jpibfi.ButtonPosition.Middle:
                            position.left = Math.round(position.left + imageDimensions.width / 2 - that._settings.pinImageWidth / 2);
                            position.top = Math.round(position.top + imageDimensions.height / 2 - that._settings.pinImageHeight / 2);
                            break;
                    }
                    $image.after($button);
                    $button
                        .show()
                        .offset({ left: position.left, top: position.top });
                }
                $image.addClass('pinit-hover');
            });
            $(document).delegate('img[data-jpibfi-indexer]', 'mouseleave', function () {
                var indexer = $(this).data("jpibfi-indexer");
                var $button = $('a.pinit-button[data-jpibfi-indexer="' + indexer + '"]');
                jpibfi.Utils.startHide($button);
            });
        };
        return Plugin;
    })();
    (function () {
        "use strict";
        $(document).ready(function () {
            var plugin = new Plugin(jpibfi_options);
            plugin.init();
        });
    })();
})(jpibfi || (jpibfi = {}));
