module jpibfi {
    export class Settings {
        /* MARGINS */
        buttonMarginTop: number;
        buttonMarginRight: number;
        buttonMarginBottom: number;
        buttonMarginLeft: number;
        buttonPosition: ButtonPosition;
        debug: boolean;
        descriptionOption: number;
        imageSelector: string;
        minImageWidth: number;
        minImageHeight: number;
        pageDescription: string;
        pageTitle: string;
        pageUrl: string;
        pinImageHeight: number;
        pinImageWidth: number;
        retinaFriendly: boolean;
        siteTitle: string;
        usePostUrl: boolean;
        /* SELECTORS */
        containerSelector: string;
        filterSelector: string = '*';
        notSelector: string = '';

        constructor(settings: any) {
            this.buttonMarginTop = parseInt(settings.buttonMarginTop);
            this.buttonMarginRight = parseInt(settings.buttonMarginRight);
            this.buttonMarginBottom = parseInt(settings.buttonMarginBottom);
            this.buttonMarginLeft = parseInt(settings.buttonMarginLeft);
            this.buttonPosition = settings.hasOwnProperty('buttonPosition') ? parseInt(settings.buttonPosition) : 4;
            this.debug = settings.hasOwnProperty('debug') ? settings.debug == '1' : false;
            this.descriptionOption = settings.hasOwnProperty('descriptionOption') ? parseInt(settings.descriptionOption) : 1;
            this.imageSelector = settings.imageSelector;
            this.minImageWidth = settings.hasOwnProperty('minImageWidth') ? parseInt(settings.minImageWidth) : 0;
            this.minImageHeight = settings.hasOwnProperty('minImageHeight') ? parseInt(settings.minImageHeight) : 0;
            this.pageDescription = settings.pageDescription;
            this.pageTitle = settings.pageTitle;
            this.pageUrl = settings.pageUrl;
            this.pinImageHeight = parseInt(settings.pinImageHeight);
            this.pinImageWidth = parseInt(settings.pinImageWidth);
            this.retinaFriendly = settings.hasOwnProperty('retinaFriendly') ? settings.retinaFriendly == 1 : false;
            this.siteTitle = settings.siteTitle;
            this.usePostUrl = settings.hasOwnProperty('usePostUrl') ? settings.usePostUrl : true;
            
            /* SELECTORS*/
            this.containerSelector = settings.containerSelector;
            this.notSelector = settings.hasOwnProperty('disabledClasses') ? Utils.createSelectorFromList(settings.disabledClasses) : '';
            this.filterSelector = settings.hasOwnProperty('enabledClasses') ? Utils.createSelectorFromList(settings.enabledClasses) || "*" : '*';

            this.adjustPinImageSize();
        }

        private adjustPinImageSize() {
            if (this.retinaFriendly) {
                this.pinImageHeight = Math.ceil(this.pinImageHeight / 2);
                this.pinImageWidth = Math.ceil(this.pinImageWidth / 2);
            }
        }

    }
}